/* $Id: exaudio.h,v 1.5 2003/01/30 02:15:39 cochran Exp $
 *
 *  Copyright (c) 2003 Richard Cochran (cochran@cs.umass.edu)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 */

#define ERR(format,arg...)  printk(KERN_ERR "exaudio: " format "\n" , ## arg)
#define INFO(format,arg...) printk(KERN_INFO "exaudio: " format "\n" , ## arg)

#define SET_CUR    0x01   /* Audio Class specific Request Codes */
#define GET_CUR    0x81
#define SET_MIN    0x02
#define GET_MIN    0x82
#define SET_MAX    0x03
#define GET_MAX    0x83
#define SET_RES    0x04
#define GET_RES    0x84
#define SET_MEM    0x05
#define GET_MEM    0x85
#define GET_STAT   0xff

/*  A "struct extigy" is created for each extigy connected to the bus.
 *  Of course you are going to use more than one at the same time...
 */
struct extigy {
  struct list_head   audiodev; /* points to next (!) extigy */
  struct usb_device* usbdev;
  struct list_head   audiolist;
  struct list_head   mixerlist;
  unsigned count; /* usage count (the usb stack is also considered a user) */
  unsigned char* desc;
  unsigned int   desclen;
  struct urb     irurb;
  unsigned char  irbuf[8];
  __u16          ircnt;
  __u32          irval;
};

/*  release()
 *
 *  Should be called with open_sem hold, so that no new processes
 *  look at the audio device to be destroyed.
 *
 *  This decrements exy->count, and calls up()
 *
 *  I (RPC) don't like this function. It is from the original audio.c and
 *  it will have to stay, for now.
 */
void release(struct extigy *s);
