/*
 *  linux/fs/supermount/mediactl.c
 *
 *  Original version:
 *      Copyright (C) 1995, 1997
 *      Stephen Tweedie (sct@dcs.ed.ac.uk)
 *
 *  Rewriten for kernel 2.2, 2.4. (C) 1999, 2000 Alexis Mikhailov
 *                                    (alexis@abc.cap.ru)
 *
 */

#include <linux/errno.h>
#include <linux/fs.h>
#include <linux/major.h>
#include <linux/cdrom.h>

#include "supermount_i.h"

/* 
 * Try to lock the drive door.  This is not guaranteed to work on all
 * hardware, but we try any tricks we know of anyway.  
 */
void
supermount_handle_door(struct super_block *sb, int operation)
{
	kdev_t dev;
	int major;
	const struct block_device_operations *fops;
	struct supermount_sb_info *sbi = supermount_sbi(sb);
	struct super_block *subsb = supermount_subfs_sb(sbi);

	dev = subsb->s_dev;
	major = MAJOR(dev);
	if (major >= MAX_BLKDEV || !(fops = get_blkfops(major)))
		return;
	if (!fops->mediactl)
		return;
	fops->mediactl(dev, operation, 0);
}
