#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/gracl.h>

static const char * restab_log[11] = {
	"RLIMIT_CPU",
	"RLIMIT_FSIZE",
	"RLIMIT_DATA",
	"RLIMIT_STACK",
	"RLIMIT_CORE",
	"RLIMIT_RSS",
	"RLIMIT_NPROC",
	"RLIMIT_NOFILE",
	"RLIMIT_MEMLOCK",
	"RLIMIT_AS",
	"RLIMIT_LOCKS"
};

__inline__ void gr_log_resource(const struct task_struct *task,
				const int res, const unsigned long wanted)
{
	if (unlikely(wanted >= task->rlim[res].rlim_cur))
		security_alert(GR_RESOURCE_MSG, GR_RESOURCE_FLD,
				wanted, restab_log[res],
				task->rlim[res].rlim_cur,
				task->comm, task->pid, task->uid, task->euid,
				task->p_pptr->comm, task->p_pptr->pid,
				task->p_pptr->uid, task->p_pptr->euid);

	return;
}
