#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/sched.h>
#include <linux/file.h>
#include <linux/ipc.h>
#include <linux/gracl.h>

struct shmid_kernel
{
        struct kern_ipc_perm    shm_perm;
        struct file *           shm_file;
        int                     id;
        unsigned long           shm_nattch;
        unsigned long           shm_segsz;
        time_t                  shm_atim;
        time_t                  shm_dtim;
        time_t                  shm_ctim;
        pid_t                   shm_cprid;
        pid_t                   shm_lprid;

        /* added by grsecurity */
        time_t                  shm_createtime;
	pid_t			shm_lapid;
};

int gr_handle_shmat(const struct shmid_kernel *shp)
{
	struct task_struct *task;

	if (!gr_acl_is_enabled())
		return 1;

	task = find_task_by_pid(shp->shm_cprid);

	if (unlikely(!task))
		task = find_task_by_pid(shp->shm_lapid);

	if (unlikely(task && ((task->start_time < shp->shm_createtime) ||
		     (task->pid == shp->shm_lapid)) &&
		     (task->acl->mode & GR_PROTSHM) &&
		     (task->acl != current->acl)))
		return 0;

	return 1;
}
